package pl.edu.amu.wmi.min.relativecardinality;

import java.util.Locale;
import pl.edu.amu.wmi.min.relativecardinality.algorithm.Algorithm;
import pl.edu.amu.wmi.min.relativecardinality.algorithm.GEKMAlgorithm;
import pl.edu.amu.wmi.min.relativecardinality.functions.Functions;
import pl.edu.amu.wmi.min.relativecardinality.functions.MinExactFunctions;

/**
 *
 * @author bikol
 */
public class Main {

    static {
        Locale.setDefault(Locale.ENGLISH);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        //this code computes lower and upper bounds of relative cardinality of IVFS
        // sigma(A|B) = [upper,lower]
        
        double[] lA = new double[]{0.4,0.3,0.76};
        double[] uA = new double[]{0.6,0.7,0.96};
        double[] lB = new double[]{0.1,0.5,0.25};
        double[] uB = new double[]{0.5, 1, 0.3};
        
        Functions tnorm = new MinExactFunctions();
        
        Algorithm algorithm = new GEKMAlgorithm();
        double lower = algorithm.computeLowerBound(lB, uB, lA, tnorm, Algorithm.Accuracy.STANDARD, new NoOp()).getValue();
        double upper = algorithm.computeLowerBound(lB, uB, uA, tnorm, Algorithm.Accuracy.STANDARD, new NoOp()).getValue();
        
        System.out.printf("[%.4f,%.4f]\n",lower, upper);
    }

}
