/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.edu.amu.wmi.min.relativecardinality.algorithm;

import org.apache.commons.math3.optim.PointValuePair;
import pl.edu.amu.wmi.min.relativecardinality.functions.Functions;

/**
 *
 * @author bikol
 */
public interface Algorithm {

    PointValuePair computeLowerBound(double[] wl, double[] wu, double[] x, Functions functions, Accuracy accuracy, Monitor monitor);

    PointValuePair computeUpperBound(double[] wl, double[] wu, double[] x, Functions functions, Accuracy accuracy, Monitor monitor);

    public static interface Monitor {

        public void started();

        public void afterInit();

        public void iterationStarted(double y, double lastChange, int k);

        public void innerIterationStarted(double y, double lastChange, int k);

        public void computingUStarted();

        public void computingUFinished();

        public void solutionFound(double y, double change, int k, double nominator,double denominator);

        public void finished();

    }

    public enum Accuracy {

        HIGH,
        STANDARD;
    }
}
