/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.edu.amu.wmi.min.relativecardinality.functions;

import static org.apache.commons.math3.util.FastMath.pow;

/**
 *
 * @author bikol
 */
public class DombiFunctions extends AbstractFunctionsWithP {

    private final double lambda;

    public DombiFunctions(double lambda) {
        super("Dombi");
        this.lambda = lambda;
    }

    @Override
    public double getParam() {
        return lambda;
    }

    @Override
    public double f(double a, double b) {
        if (a == 0 && b == 0) {
            return 0;
        } else {
            return 1.0 / (1.0 + pow(pow((1.0 - a) / a, lambda) + pow((1.0 - b) / b, lambda), 1.0 / lambda));
        }
    }

    @Override
    protected boolean compute() {
        return lambda<1;
    }
}
