/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.edu.amu.wmi.min.relativecardinality.functions;

import static org.apache.commons.math3.util.FastMath.log;
import static org.apache.commons.math3.util.FastMath.pow;

/**
 *
 * @author bikol
 */
public class FrankFunctions extends AbstractFunctions {

    private final double lambda;

    public FrankFunctions(double lambda) {
        super("Frank");
        this.lambda = lambda;
    }

    @Override
    public double getParam() {
        return lambda;
    }
    
    @Override
    public double f(double a, double b) {
        if (lambda == 0) {
            return Math.min(a, b);
        } else if (lambda == 1) {
            return a * b;
        } else {
            return log(lambda, 1.0 + ((pow(lambda, a) - 1.0) * (pow(lambda, b) - 1.0)) / (lambda - 1.0));
        }
    }
}
