package pl.edu.amu.wmi.min.relativecardinality.functions;

/**
 *
 * @author bikol
 */
public final class FunctionsUtils {

    public static final Functions MIN = new MinFunctions(),
            PROD = new ProdFunctions(),
            LUK = new ŁukFunctions(),
            SSm5 = new SSFunctions(-5.0),
            SSm2 = new SSFunctions(-2.0),
            SSm15 = new SSFunctions(-1.5),
            SSm025 = new SSFunctions(-0.25),
            SSm05 = new SSFunctions(-0.5),
            SSm075 = new SSFunctions(-0.75),
            SS025 = new SSFunctions(0.25),
            SS05 = new SSFunctions(0.5),
            SS075 = new SSFunctions(0.75),
            SS15 = new SSFunctions(1.5),
            SS2 = new SSFunctions(2.0),
            SS5 = new SSFunctions(5.0),
            SWm075 = new SWFunctions(-0.75),
            SWm05 = new SWFunctions(-0.5),
            SWm025 = new SWFunctions(-0.25),
            SW025 = new SWFunctions(0.25),
            SW05 = new SWFunctions(0.5),
            SW075 = new SWFunctions(0.75),
            SW15 = new SWFunctions(1.5),
            SW2 = new SWFunctions(2),
            SW5 = new SWFunctions(5),
            F025 = new FrankFunctions(0.25),
            F05 = new FrankFunctions(0.5),
            F075 = new FrankFunctions(0.75),
            F15 = new FrankFunctions(1.5),
            F2 = new FrankFunctions(2),
            F5 = new FrankFunctions(5),
            H025 = new HamFunctions(0.25),
            H05 = new HamFunctions(0.5),
            H075 = new HamFunctions(0.75),
            H15 = new HamFunctions(1.5),
            H2 = new HamFunctions(2),
            H5 = new HamFunctions(5),
            Y025 = new YagerFunctions(0.25),
            Y05 = new YagerFunctions(0.5),
            Y075 = new YagerFunctions(0.75),
            Y15 = new YagerFunctions(1.5),
            Y2 = new YagerFunctions(2),
            Y5 = new YagerFunctions(5),
            D025 = new DombiFunctions(0.25),
            D05 = new DombiFunctions(0.5),
            D075 = new DombiFunctions(0.75),
            D15 = new DombiFunctions(1.5),
            D2 = new DombiFunctions(2),
            D5 = new DombiFunctions(5);

    public static final Functions POLY1 = new PolynominalFunctions(new double[]{0, 6.55556, -16.6667, 11.1111}),
            POLY2 = new PolynominalFunctions(new double[]{0, 11.0198, -89.5833, 368.364, -848.765, 1111.11, -771.605, 220.459}),
            POLY3 = new PolynominalFunctions(new double[]{0, 0, 1}),
            POLY4 = new PolynominalFunctions(new double[]{0, 0, 0, 1}),
            //0. + 3. x - 6. x^2 + 4 x^3
            POLY5 = new PolynominalFunctions(new double[]{0, 3, -6, 4}),
            //-0.25 + 3. x - 6. x^2 + 4 x^3
            POLY6 = new PolynominalFunctions(new double[]{-0.25, 3, -6, 4});
    public static final Functions[] FUNCTIONS_SMALL = new Functions[]{MIN, LUK, PROD, SSm2, SSm05, SS05, SS2, SWm05, SW05, SW2, F05, F2, H05, H2, Y05, Y2, D05, D2};
    public static final Functions[] FUNCTIONS = new Functions[]{MIN, LUK, PROD, SSm5, SSm2, SSm025, SSm05, SSm075, SS025, SS05, SS075, SS15, SS2, SS5, SWm025, SWm05, SWm075, SW025, SW05, SW075, SW15, SW2, SW5, F025, F05, F075, F15, F2, F5, H025, H05, H075, H15, H2, H5, Y025, Y05, Y075, Y15, Y2, Y5, D025, D05, D075, D15, D2, D5};

    public static final Functions[] POLYS = new Functions[]{POLY6};

}
