package pl.edu.amu.wmi.min.relativecardinality.functions;

import org.apache.commons.math3.util.FastMath;

/**
 *
 * @author bikol
 */
public class PolynominalFunctions extends AbstractFunctionsWithP {

    private final double[] coeff;

    private static String name(double[] c) {
        StringBuilder sb = new StringBuilder(c.length * 15);
        for (int i = 0; i < c.length; i++) {
            if (i == 0) {
                sb.append(c[i]).append("+");
            } else if (i == 1) {
                sb.append(c[i]).append("*x+");
            } else {
                sb.append(c[i]).append("*x^").append(i).append("+");
            }
        }
        return sb.toString();
    }

    public PolynominalFunctions(double[] coeff) {
        super("POLY(" + name(coeff) + ")");
        this.coeff=coeff;
    }

    @Override
    protected boolean compute() {
        return true;
    }

    @Override
    public double f(double x, double w) {
        double result = 0.0;
        for (int i = 0; i < coeff.length; i++) {
            result += coeff[i] * FastMath.pow(w, i);
        }
        if (result < 0) {
            result = 0.0;
        }
        if (x * result > 1) {
            return 1.0;
        } else {
            return x * result;
        }
    }

}
