package pl.edu.amu.wmi.min.relativecardinality.functions;

import static org.apache.commons.math3.util.FastMath.max;
import static org.apache.commons.math3.util.FastMath.pow;

/**
 *
 * @author bikol
 */
public class SSFunctions extends AbstractFunctions {

    private final double lambda;

    public SSFunctions(double lambda) {
        super("SS");
        this.lambda = lambda;
    }

    @Override
    public double getParam() {
        return lambda;
    }

    @Override
    public double f(double a, double b) {
        if (lambda == 0) {
            return a * b;
        } else {
            if (lambda < 0) {
                return pow(pow(a, lambda) + pow(b, lambda) - 1.0, 1.0 / lambda);
            } else {
                return pow(max(0, pow(a, lambda) + pow(b, lambda) - 1.0), 1.0 / lambda);
            }
        }
    }

}
