/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.edu.amu.wmi.min.relativecardinality.functions;

import static org.apache.commons.math3.util.FastMath.max;
import static org.apache.commons.math3.util.FastMath.pow;

/**
 *
 * @author bikol
 */
public class YagerFunctions extends AbstractFunctionsWithP {

    private final double lambda;

    public YagerFunctions(double lambda) {
        super("Yager");
        this.lambda = lambda;
    }

    @Override
    public double getParam() {
        return lambda;
    }

    @Override
    public double f(double a, double b) {
        return max(0, 1.0 - pow(pow(1.0 - a, lambda) + pow(1.0 - b, lambda), 1.0 / lambda));
    }

    @Override
    protected boolean compute() {
        return lambda>1;
    }

}
